#include <Servo.h>

#define echoPin1 2 // attach pin D2 Arduino to pin Echo of HC-SR04
#define trigPin1 3 // attach pin D3 Arduino to pin Trig of HC-SR04
#define echoPin2 5 // attach pin D5 Arduino to pin Echo of HC-SR04
#define trigPin2 6 // attach pin D6 Arduino to pin Trig of HC-SR04
#define echoPin3 7 // attach pin D7 Arduino to pin Echo of HC-SR04
#define trigPin3 8 // attach pin D8 Arduino to pin Trig of HC-SR04


Servo myservo1; 

// create servo object to control a servo
Servo myservo2;
int pos1 = 90; // define the default position in the beginning
int pos2 = 90;    

long duration1; // variable for the duration of sound wave travel for the first HC-SR04
long duration2; // variable for the duration of sound wave travel for the second HC-SR04
long duration3; // variable for the duration of sound wave travel for the third HC-SR04
int distance1; // variable for the distance measurement for the first HC-SR04
int distance2; // variable for the distance measurement for the second HC-SR04
int distance3; // variable for the distance measurement for the third HC-SR04

void setup() {
  myservo1.attach(9);  // attaches the servo on pin 9 to the servo object
  myservo2.attach(10);  // attaches the servo on pin 10 to the servo object
  pinMode(trigPin1, OUTPUT); 
  pinMode(echoPin1, INPUT);
  pinMode(trigPin2, OUTPUT); 
  pinMode(echoPin2, INPUT); 
  pinMode(trigPin3, OUTPUT); 
  pinMode(echoPin3, INPUT);
  Serial.begin(9600); // Serial Communication is starting with 9600 of baudrate speed
  pinMode(13,OUTPUT); // We define the LED and and make sure it's off in the beginning
  digitalWrite(13,LOW);
}

void loop() {
  digitalWrite(trigPin1, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin1, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin1, LOW);
  duration1 = pulseIn(echoPin1, HIGH);
  // Calculating the distance
  distance1 = duration1 * 0.034 / 2; // Speed of sound wave divided by 2 (go and back)
  Serial.println(distance1); //prints the distance
  delay(20);

  digitalWrite(trigPin2, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin2, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin2, LOW);
  duration2 = pulseIn(echoPin2, HIGH);
  // Calculating the distance
  distance2 = duration2 * 0.034 / 2; // Speed of sound wave divided by 2 (go and back)
  Serial.println(distance2); //prints the distance
  delay(20);

  digitalWrite(trigPin3, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin3, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin3, LOW);
  duration3 = pulseIn(echoPin3, HIGH);
  // Calculating the distance
  distance3 = duration3 * 0.034 / 2; // Speed of sound wave divided by 2 (go and back)
  Serial.println(distance3); //prints the distance
  delay(20);

  if((distance1 <= 60) && ((distance2 >= 60) && (distance3 >= 60))){ // Now if the sensor 1 gets activated the servos will spin to point its position
    pos1 = 60;
    myservo1.write(pos1);
    pos2 = 60;
    myservo2.write(pos2);
    delay(50);
    digitalWrite(13,LOW);
  } else if((distance2 <= 60) && ((distance1 >= 60) && (distance3 >= 60))){ // Now if the sensor 2 gets activated the servos will spin to point its position
    pos1 = 120;
    myservo1.write(pos1);
    pos2 = 120;
    myservo2.write(pos2);
    delay(50);
    digitalWrite(13,LOW);
  } else if((distance3 <= 60) && ((distance1 >= 60) && (distance2 >= 60))){ // Now if the sensor 3 gets activated the servos will spin to point its position
    pos1 = 150;
    myservo1.write(pos1);
    pos2 = 150;
    myservo2.write(pos2);
    delay(50);
    digitalWrite(13,LOW);
  } else if((distance1 <= 60) && (distance2 <= 60) || (distance2 <= 60) && (distance3 <= 60) || (distance1 <= 60) && (distance3 <= 60)){
    pos1 = 90;
    myservo1.write(pos1);
    pos2 = 90;
    myservo2.write(pos2);
    digitalWrite(13,HIGH);
    delay(50);
  }else{ // if none of the sensors get activated it will return to its default position
    pos1 = 90;
    myservo1.write(pos1);
    pos2 = 90;
    myservo2.write(pos2);
    delay(50);
    digitalWrite(13,LOW);
  }
}
